From 24691ec239b3b1a93e8a120e84dfd404f4914071 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Tue, 30 Jul 2019 11:30:57 -0400
Subject: [PATCH 15/31] initial work on SquadInvitationRequestMessage packet,
 originally by aphedox; initial work on packet and tests for
 CharacterKnowledgeMessage; re-organization of SquadService workflow;
 prototyping for SquadSwitchboard

---
 .../psforever/packet/GamePacketOpcode.scala   |   4 +-
 .../game/CharacterKnowledgeMessage.scala      |  57 ++
 .../game/SquadInvitationRequestMessage.scala  |  41 +
 .../services/teamwork/SquadResponse.scala     |   4 +-
 .../services/teamwork/SquadService.scala      | 732 +++++++++---------
 .../services/teamwork/SquadSwitchboard.scala  | 142 ++++
 .../game/CharacterKnowledgeMessageTest.scala  |  70 ++
 .../src/main/scala/WorldSessionActor.scala    | 108 ++-
 8 files changed, 765 insertions(+), 393 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/packet/game/CharacterKnowledgeMessage.scala
 create mode 100644 common/src/main/scala/net/psforever/packet/game/SquadInvitationRequestMessage.scala
 create mode 100644 common/src/main/scala/services/teamwork/SquadSwitchboard.scala
 create mode 100644 common/src/test/scala/game/CharacterKnowledgeMessageTest.scala

diff --git a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
index 03ed5e25..54452c55 100644
--- a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
+++ b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
@@ -595,8 +595,8 @@ object GamePacketOpcode extends Enumeration {
     case 0xe8 => game.SquadDetailDefinitionUpdateMessage.decode
     case 0xe9 => noDecoder(TacticsMessage)
     case 0xea => noDecoder(RabbitUpdateMessage)
-    case 0xeb => noDecoder(SquadInvitationRequestMessage)
-    case 0xec => noDecoder(CharacterKnowledgeMessage)
+    case 0xeb => game.SquadInvitationRequestMessage.decode
+    case 0xec => game.CharacterKnowledgeMessage.decode
     case 0xed => noDecoder(GameScoreUpdateMessage)
     case 0xee => noDecoder(UnknownMessage238)
     case 0xef => noDecoder(OrderTerminalBugMessage)
diff --git a/common/src/main/scala/net/psforever/packet/game/CharacterKnowledgeMessage.scala b/common/src/main/scala/net/psforever/packet/game/CharacterKnowledgeMessage.scala
new file mode 100644
index 00000000..3b9710a3
--- /dev/null
+++ b/common/src/main/scala/net/psforever/packet/game/CharacterKnowledgeMessage.scala
@@ -0,0 +1,57 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.packet.game
+
+import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
+import net.psforever.types.CertificationType
+import scodec.Codec
+import scodec.codecs._
+import shapeless.{::, HNil}
+
+final case class CharacterKnowledgeInfo(name : String,
+                                        permissions : Set[CertificationType.Value],
+                                        unk1 : Int,
+                                        unk2 : Int,
+                                        unk3 : PlanetSideGUID)
+
+final case class CharacterKnowledgeMessage(char_id : Long,
+                                           info : Option[CharacterKnowledgeInfo])
+  extends PlanetSideGamePacket {
+  type Packet = CharacterKnowledgeMessage
+  def opcode = GamePacketOpcode.CharacterKnowledgeMessage
+  def encode = CharacterKnowledgeMessage.encode(this)
+}
+
+object CharacterKnowledgeMessage extends Marshallable[CharacterKnowledgeMessage] {
+  def apply(char_id : Long) : CharacterKnowledgeMessage =
+    CharacterKnowledgeMessage(char_id, None)
+
+  def apply(char_id : Long, info : CharacterKnowledgeInfo) : CharacterKnowledgeMessage =
+    CharacterKnowledgeMessage(char_id, Some(info))
+
+  private val inverter : Codec[Boolean] = bool.xmap[Boolean] (
+    state => !state,
+    state => !state
+  )
+
+  private val info_codec : Codec[CharacterKnowledgeInfo] = (
+    ("name" | PacketHelpers.encodedWideStringAligned(adjustment = 7)) ::
+      ("permissions" | ulongL(bits = 46)) ::
+      ("unk1" | uint(bits = 6)) ::
+      ("unk2" | uint(bits = 3)) ::
+      ("unk3" | PlanetSideGUID.codec)
+  ).xmap[CharacterKnowledgeInfo] (
+    {
+      case name :: permissions :: u1 :: u2 :: u3 :: HNil =>
+        CharacterKnowledgeInfo(name, CertificationType.fromEncodedLong(permissions), u1, u2, u3)
+    },
+    {
+      case CharacterKnowledgeInfo(name, permissions, u1, u2, u3) =>
+        name :: CertificationType.toEncodedLong(permissions) :: u1 :: u2 :: u3 :: HNil
+    }
+  )
+
+  implicit val codec : Codec[CharacterKnowledgeMessage] = (
+    ("char_id" | uint32L) ::
+      ("info" | optional(inverter, info_codec))
+    ).as[CharacterKnowledgeMessage]
+}
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadInvitationRequestMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadInvitationRequestMessage.scala
new file mode 100644
index 00000000..60de66e1
--- /dev/null
+++ b/common/src/main/scala/net/psforever/packet/game/SquadInvitationRequestMessage.scala
@@ -0,0 +1,41 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.packet.game
+
+import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
+import scodec.Codec
+import scodec.codecs._
+
+/**
+  * A message for communicating squad invitation.
+  * When received by a client, the event message "You have invited `name` to join your squad" is produced
+  * and a `SquadMembershipRequest` packet of type `Invite`
+  * using `char_id` as the optional unique character identifier field is dispatched to the server.
+  * The message is equivalent to a dispatched packet of type `SquadMembershipResponse`
+  * with an `Invite` event with the referral field set to `true`.
+  * @see `SquadMembershipResponse`
+  * @param squad_guid the squad's GUID
+  * @param slot a potentially valid slot index;
+  *             0-9; higher numbers produce no response
+  * @param char_id the unique character identifier
+  * @param name the character's name;
+  *             frequently, though that does not produce a coherent message,
+  *             the avatar's own name is supplied in the event message instead of the name of another player
+  */
+final case class SquadInvitationRequestMessage(squad_guid : PlanetSideGUID,
+                                               slot : Int,
+                                               char_id : Long,
+                                               name : String)
+  extends PlanetSideGamePacket {
+  type Packet = SquadInvitationRequestMessage
+  def opcode = GamePacketOpcode.SquadInvitationRequestMessage
+  def encode = SquadInvitationRequestMessage.encode(this)
+}
+
+object SquadInvitationRequestMessage extends Marshallable[SquadInvitationRequestMessage] {
+  implicit val codec : Codec[SquadInvitationRequestMessage] = (
+    ("squad_guid" | PlanetSideGUID.codec) ::
+      ("slot" | uint4) ::
+      ("char_id" | uint32L) ::
+      ("name" | PacketHelpers.encodedWideStringAligned(adjustment = 4))
+    ).as[SquadInvitationRequestMessage]
+}
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index b74f153f..26215f02 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -21,7 +21,7 @@ object SquadResponse {
   final case class Join(squad : Squad, positionsToUpdate : List[Int]) extends Response
   final case class Leave(squad : Squad, positionsToUpdate : List[(Long, Int)]) extends Response
   final case class UpdateMembers(squad : Squad, update_info : List[SquadAction.Update]) extends Response
-  final case class SwapMember(squad : Squad, from_index : Int, to_index : Int) extends Response
+  final case class AssignMember(squad : Squad, from_index : Int, to_index : Int) extends Response
 
-  final case class Detail(guid : PlanetSideGUID, leader : String, task : String, zone : PlanetSideZoneID, member_info : List[SquadPositionDetail]) extends Response
+  final case class Detail(guid : PlanetSideGUID, squad_detail : SquadDetail) extends Response
 }
diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 0f8ae794..e3dbe592 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1,7 +1,7 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import akka.actor.Actor
+import akka.actor.{Actor, ActorRef, Props}
 import net.psforever.objects.Player
 import net.psforever.objects.definition.converter.StatConverter
 import net.psforever.objects.loadouts.SquadLoadout
@@ -21,6 +21,7 @@ class SquadService extends Actor {
 
   private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
   private var idToSquad : TrieMap[PlanetSideGUID, Squad] = new TrieMap[PlanetSideGUID, Squad]()
+  private var idToSwitchboard : TrieMap[PlanetSideGUID, ActorRef] = new TrieMap[PlanetSideGUID, ActorRef]()
   private var i : Int = 1
   private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
     PlanetSideEmpire.TR -> ListBuffer.empty,
@@ -28,6 +29,7 @@ class SquadService extends Actor {
     PlanetSideEmpire.VS -> ListBuffer.empty
   )
   private val bids : mutable.LongMap[PositionBid] = mutable.LongMap[PositionBid]()
+  private val viewDetails : mutable.LongMap[PlanetSideGUID] = mutable.LongMap[PlanetSideGUID]()
 
   private [this] val log = org.log4s.getLogger
 
@@ -82,51 +84,55 @@ class SquadService extends Actor {
     PlanetSideGUID(out)
   }
 
-  def GetParticipatingSquad(player : Player, zone : Int) : Option[Squad] = {
+  def GetParticipatingSquad(player : Player) : Option[Squad] = {
     memberToSquad.get(player.CharId) match {
-      case opt @ Some(squad) =>
-        squad.Membership.find(_.Name == player.Name).get.ZoneId = zone
+      case opt @ Some(_) =>
         opt
       case None =>
         None
     }
   }
 
-  def GetLeadingSquad(player : Player, zone : Int, opt : Option[Squad]) : Squad = {
+  def GetLeadingSquad(player : Player, zone : Int, opt : Option[Squad]) : Option[Squad] = {
     val charId = player.CharId
-    val squadOut = opt match {
+    opt match {
       case Some(squad) =>
         if(squad.Leader.CharId == charId) {
-          squad
+          Some(squad)
         }
         else {
-          GetLeadingSquad(player, zone, None)
+          None
         }
 
       case None =>
         memberToSquad.get(charId) match {
-          case Some(squad) if squad.Leader.CharId.equals(charId) =>
-            squad
+          case Some(squad) if squad.Leader.CharId == charId =>
+            Some(squad)
           case _ =>
-            val faction = player.Faction
-            val id = GetNextSquadId()
-            val squad = new Squad(id, faction)
-            val leadPosition = squad.Membership(squad.LeaderPositionIndex)
-            val name = player.Name
-            leadPosition.Name = name
-            leadPosition.CharId = charId
-            leadPosition.Health = player.Health
-            leadPosition.Armor = player.Armor
-            leadPosition.Position = player.Position
-            leadPosition.ZoneId = zone
-            log.info(s"$name-$faction has started a new squad")
-            memberToSquad += charId -> squad
-            idToSquad += id -> squad
-            squad
+            None
         }
     }
-    squadOut.Membership(squadOut.LeaderPositionIndex).ZoneId = zone
-    squadOut
+  }
+
+  def StartSquad(player : Player) : Squad = {
+    val charId = player.CharId
+    val faction = player.Faction
+    val id = GetNextSquadId()
+    val name = player.Name
+    val squad = new Squad(id, faction)
+    val leadPosition = squad.Membership(squad.LeaderPositionIndex)
+    leadPosition.Name = name
+    leadPosition.CharId = charId
+    leadPosition.Health = player.Health
+    leadPosition.Armor = player.Armor
+    leadPosition.Position = player.Position
+    leadPosition.ZoneId = 1
+    val switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${id.guid}")
+    memberToSquad += charId -> squad
+    idToSquad += id -> squad
+    idToSwitchboard += id -> switchboard
+    log.info(s"$name-$faction has started a new squad")
+    squad
   }
 
   val SquadEvents = new GenericEventBus[SquadServiceResponse]
@@ -134,16 +140,16 @@ class SquadService extends Actor {
   def receive : Receive = {
     //subscribe to a faction's channel - necessary to receive updates about listed squads
     case Service.Join(faction) if "TRNCVS".indexOf(faction) > -1 =>
-      val path = s"$faction/Squad"
+      val path = s"/$faction/Squad"
       val who = sender()
       log.info(s"$who has joined $path")
       SquadEvents.subscribe(who, path)
       //send initial squad catalog
-      sender ! SquadServiceResponse(s"$faction/Squad", SquadResponse.InitList(publishedLists(PlanetSideEmpire(faction)).toVector))
+      sender ! SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(publishedLists(PlanetSideEmpire(faction)).toVector))
 
     //subscribe to the player's personal channel - necessary only to inform about any previous squad association
     case Service.Join(char_id) =>
-      val path = s"$char_id/Squad"
+      val path = s"/$char_id/Squad"
       val who = sender()
       log.info(s"$who has joined $path")
       SquadEvents.subscribe(who, path) //TODO squad-specific switchboard
@@ -195,101 +201,80 @@ class SquadService extends Actor {
     case SquadServiceMessage(tplayer, squad_action) => squad_action match {
       case SquadAction.Membership(request_type, char_id, optional_char_id, _, _) => request_type match {
         case SquadRequestType.Invite =>
+          //char_id is the inviter, e.g., the (prospective) squad leader
+          //this is just busy work; for actual joining operations, see SquadRequestType.Accept
           (optional_char_id, memberToSquad.get(char_id)) match {
-            case (Some(toCharId), Some(squad)) =>
-              bids(toCharId) = VacancyBid(char_id, squad.GUID)
-              SquadEvents.publish( SquadServiceResponse(s"$toCharId/Squad", SquadResponse.Invite(char_id, toCharId, tplayer.Name)) )
-            case (Some(toCharId), None) =>
-              val ourSquad = GetLeadingSquad(tplayer, 1, None)
-              memberToSquad.remove(char_id)
-              bids(toCharId) = CamraderieBid(char_id, ourSquad)
-              SquadEvents.publish( SquadServiceResponse(s"$toCharId/Squad", SquadResponse.Invite(char_id, toCharId, tplayer.Name)) )
+            case (Some(invitee), Some(squad)) =>
+              bids(invitee) = VacancyBid(char_id, squad.GUID)
+              log.info(s"$invitee has been invited to squad ${squad.Task} by $char_id")
+              SquadEvents.publish( SquadServiceResponse(s"/$invitee/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, char_id, Some(invitee), tplayer.Name, false, Some(None))) )
+              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitee, Some(char_id), tplayer.Name, true, Some(None))) )
+            case (Some(invitee), None) =>
+              //the inviter does not currently belong to a squad; check for an existing placeholder, or create a new one
+              val ourSquad = {
+                bids.find { case (inviter, _) => inviter == char_id } match {
+                  case Some((_, SpontaneousBid(_, _squad))) =>
+                    _squad //borrow
+                  case _ =>
+                    val _squad = StartSquad(tplayer)
+                    memberToSquad.remove(char_id) //completely unlist until assured the squad is necessary
+                    _squad
+                }
+              }
+              bids(invitee) = SpontaneousBid(char_id, ourSquad)
+              SquadEvents.publish( SquadServiceResponse(s"/$invitee/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, char_id, Some(invitee), tplayer.Name, false, Some(None))) )
+              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitee, Some(char_id), tplayer.Name, true, Some(None))) )
             case _ => ;
           }
 
-        case SquadRequestType.Leave =>
-          val squad = memberToSquad(char_id)
-          if(optional_char_id.contains(char_id)) {
-            //leaving the squad of our own accord
-          }
-          else {
-            val leader = squad.Leader
-            if(optional_char_id.contains(leader.CharId)) {
-              //kicked by the squad leader
-            }
-          }
-          val membership = squad.Membership.zipWithIndex
-          val (member, index) = membership
-            .find { case (_member, _) => _member.CharId == char_id }
-            .get
-          val updateList = membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
-          memberToSquad.remove(char_id)
-          member.Name = ""
-          member.CharId = 0
-
-          val size = squad.Size
-          if(size == 1) {
-            //squad is rendered to just one person; collapse it
-            (membership.collect({ case (_member, _) if _member.CharId > 0 => _member.CharId }) :+ char_id)
-              .foreach { charId =>
-                SquadEvents.publish( SquadServiceResponse(s"$charId/Squad", SquadResponse.Leave(squad, updateList)) )
-                memberToSquad.remove(charId)
-              }
-            idToSquad.remove(squad.GUID)
-          }
-          else {
-            //squad continues, despite player's parting
-            //member leaves the squad completely
-            sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
-            //other squad members see the member leaving only
-            val leavingMember = List((char_id, index))
-            membership
-              .collect({ case (_member, _) if _member.CharId > 0 => _member.CharId })
-              .foreach { charId =>
-                SquadEvents.publish( SquadServiceResponse(s"$charId/Squad", SquadResponse.Leave(squad, leavingMember)) )
-              }
-          }
-
         case SquadRequestType.Accept =>
+          //char_id is the invitee, e.g., the person joining the squad
           bids.remove(char_id) match {
-            case Some(NormalBid(inviterCharId, squadGUID, line)) if idToSquad.get(squadGUID).nonEmpty =>
+            case Some(NormalBid(_/*inviterCharId*/, squadGUID, line)) if idToSquad.get(squadGUID).nonEmpty =>
+              //player requested to join a squad's specific position
               JoinSquad(tplayer, idToSquad(squadGUID), line)
 
             case Some(VacancyBid(inviterCharId, squadGUID)) if idToSquad.get(squadGUID).nonEmpty =>
+              //we were invited by the squad leader into an existing squad
               val squad = idToSquad(squadGUID)
               squad.Membership.zipWithIndex.find({ case (member, index) =>
-                ValidOpenSquadPosition(squad, index, squad.Membership(index), tplayer.Certifications)
+                ValidOpenSquadPosition(squad, index, member, tplayer.Certifications)
               }) match {
                 case Some((_, line)) =>
+                  SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
+                  SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
                   JoinSquad(tplayer, squad, line)
                 case _ => ;
               }
 
-            case Some(CamraderieBid(inviterCharId, placeholderSquad)) =>
-              (GetParticipatingSquad(tplayer, 1) match {
+            case Some(SpontaneousBid(inviterCharId, placeholderSquad)) =>
+              //we were invited by someone into a new squad they would form
+              (GetParticipatingSquad(tplayer) match {
                 case Some(participating) =>
                   if(participating.Leader.CharId == inviterCharId) {
                     Some(participating)
                   }
                   else {
-                    //inviter is not leader of squad; bounce this request off of the squad leader
+                    //inviter joined a squad and is not its leader; bounce this request off of the squad leader
+                    //TODO squad leader receives "<player> wants to join squad" prompt
                     val leaderCharId = participating.Leader.CharId
                     bids(char_id) = VacancyBid(leaderCharId, participating.GUID) //reframed request
-                    //TODO squad leader receives "<player> wants to join squad" prompt
-                    //SquadEvents.publish(SquadServiceResponse(s"$leaderCharId/Squad", SquadResponse.Invite(char_id, leaderCharId, tplayer.Name)))
+                    SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Invite(char_id, leaderCharId, tplayer.Name)))
                     None
                   }
                 case None =>
                   placeholderSquad.Task = s"${tplayer.Name}'s Squad"
                   memberToSquad(inviterCharId) = placeholderSquad
-                  SquadEvents.publish(SquadServiceResponse(s"$inviterCharId/Squad", SquadResponse.InitSquad(placeholderSquad.GUID)))
+                  SquadEvents.publish(SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.InitSquad(placeholderSquad.GUID)))
                   Some(placeholderSquad)
               }) match {
               case Some(squad) =>
                 squad.Membership.zipWithIndex.find({ case (member, index) =>
-                  ValidOpenSquadPosition(squad, index, squad.Membership(index), tplayer.Certifications)
+                  ValidOpenSquadPosition(squad, index, member, tplayer.Certifications)
                 }) match {
                   case Some((_, line)) =>
+                    SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
+                    SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
                     JoinSquad(tplayer, squad, line)
                   case _ => ;
                 }
@@ -299,6 +284,50 @@ class SquadService extends Actor {
             case _ => ;
           }
 
+        case SquadRequestType.Leave =>
+          //char_id is the player leaving
+          val squad = memberToSquad(char_id)
+          val leader = squad.Leader.CharId
+          if(char_id == leader) {
+            //squad leader is leaving his own squad, so it will be disbanded
+            squad.Membership
+              .filterNot { _.CharId == leader }
+              .foreach { member =>
+                val charId = member.CharId
+                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
+              }
+            CloseOutSquad(squad)
+            SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
+          }
+          else {
+            if(optional_char_id.contains(char_id)) {
+              //leaving the squad of our own accord
+              LeaveSquad(tplayer, squad)
+            }
+            else if(optional_char_id.contains(leader)) {
+              //kicked by the squad leader
+              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, char_id, Some(leader), tplayer.Name, false, Some(None))) )
+              SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(char_id), "", true, Some(None))) )
+              LeaveSquad(tplayer, squad)
+            }
+          }
+
+        case SquadRequestType.Reject =>
+          //a player has opted out of joining a squad
+          (bids.remove(char_id) match {
+            case Some(SpontaneousBid(inviterCharId, squad)) if squad.Leader.CharId != char_id =>
+              (inviterCharId, squad)
+            case Some(VacancyBid(inviterCharId, guid)) if idToSquad(guid).Leader.CharId != char_id =>
+              (inviterCharId, idToSquad.get(guid))
+            case _ => ;
+              (0L, None)
+          }) match {
+            case (inviterCharId, Some(squad)) =>
+              SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
+              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
+            case _ => ;
+          }
+
         case _ => ;
       }
 
@@ -307,10 +336,8 @@ class SquadService extends Actor {
           case Some(squad) =>
             squad.Membership.find(_.CharId == char_id) match {
               case Some(member) =>
-                val newHealth = StatConverter.Health(health, max_health, min=1, max=64)
-                val newArmor = StatConverter.Health(armor, max_armor, min=1, max=64)
-                member.Health = newHealth
-                member.Armor = newArmor
+                member.Health = StatConverter.Health(health, max_health, min=1, max=64)
+                member.Armor = StatConverter.Health(armor, max_armor, min=1, max=64)
                 member.Position = pos
                 member.ZoneId = zone_number
                 sender ! SquadServiceResponse("", SquadResponse.UpdateMembers(
@@ -328,36 +355,27 @@ class SquadService extends Actor {
 
       case SquadAction.Definition(tplayer : Player, zone_ordinal_number : Int, guid : PlanetSideGUID, line : Int, action : SquadAction) =>
         import net.psforever.packet.game.SquadAction._
-        val squadOpt = GetParticipatingSquad(tplayer, zone_ordinal_number)
+        val pSquadOpt = GetParticipatingSquad(tplayer)
+        val lSquadOpt = GetLeadingSquad(tplayer, zone_ordinal_number, pSquadOpt)
+        //the following actions can only be performed by a squad's leader
         action match {
           case SaveSquadFavorite() =>
-            squadOpt match {
-              case Some(squad) if squad.Leader.CharId == tplayer.CharId && squad.Task.nonEmpty && squad.ZoneId > 0 =>
-                tplayer.SquadLoadouts.SaveLoadout(squad, squad.Task, line)
-                sender ! SquadServiceResponse("", SquadResponse.ListSquadFavorite(line, squad.Task))
-              case _ => ;
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+            if(squad.Task.nonEmpty && squad.ZoneId > 0) {
+              tplayer.SquadLoadouts.SaveLoadout(squad, squad.Task, line)
+              sender ! SquadServiceResponse("", SquadResponse.ListSquadFavorite(line, squad.Task))
             }
 
           case LoadSquadFavorite() =>
-            (squadOpt match {
-              case Some(squad) if squad.Size == 1 =>
-                //we are the leader of our own squad, but no one else has joined yet
-                Some(squad)
-              case None => ;
-                //we are not yet member of a squad; start a squad to support our favorite definition
-                Some(GetLeadingSquad(tplayer, zone_ordinal_number, None))
-              case _ => ;
-                //player is member of populated squad; should not overwrite squad definition with favorite
-                None
-            }, tplayer.SquadLoadouts.LoadLoadout(line)) match {
-              case (Some(squad : Squad), Some(loadout : SquadLoadout)) =>
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
+            tplayer.SquadLoadouts.LoadLoadout(line) match {
+              case Some(loadout : SquadLoadout) if squad.Size == 1 =>
                 log.info(s"${tplayer.Name} is loading a squad composition: $loadout")
                 SquadService.LoadSquadDefinition(squad, loadout)
                 sender ! SquadServiceResponse("", SquadResponse.InitSquad(squad.GUID))
                 UpdateSquadList(squad, SquadInfo().Task(squad.Task).ZoneId(PlanetSideZoneID(squad.ZoneId)).Capacity(squad.Capacity))
                 UpdateSquadDetail(PlanetSideGUID(0), squad)
-
-              case _ => ;
+              case _ =>
             }
 
           case DeleteSquadFavorite() =>
@@ -366,23 +384,20 @@ class SquadService extends Actor {
 
           case ChangeSquadPurpose(purpose) =>
             log.info(s"${tplayer.Name}-${tplayer.Faction} has changed his squad's task to $purpose")
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Task = purpose
-
             UpdateSquadListWhenListed(squad, SquadInfo().Task(purpose))
-            SquadDetail().Task(purpose)
-            UpdateListedSquadDetail(squad.GUID, squad)
+            UpdateSquadDetailWhenListed(squad.GUID, squad, SquadDetail().Task(purpose))
 
           case ChangeSquadZone(zone) =>
             log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone")
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.ZoneId = zone.zoneId.toInt
             UpdateSquadListWhenListed(squad, SquadInfo().ZoneId(zone))
-            SquadDetail().ZoneId(zone)
-            UpdateListedSquadDetail(squad.GUID, squad)
+            UpdateSquadDetailWhenListed(squad.GUID, squad, SquadDetail().ZoneId(zone))
 
           case CloseSquadMemberPosition(position) =>
-            val squad = GetLeadingSquad(tplayer, zone_ordinal_number, squadOpt)
+            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
                 squad.Availability.update(position, false)
